=== debian/changelog ===
libpappsomspp (0.7.13-1) unstable; urgency=low

  * Another set of fixes for the faulty hard-coded path
    to the arch-specific system library directory.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 25 Aug 2020 13:13:48 +0200

libpappsomspp (0.7.12-1) unstable; urgency=low

  * Add new filter.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 24 Aug 2020 19:42:19 +0200

libpappsomspp (0.7.11-1) unstable; urgency=low

  * Fix problem with the shipped CMake-based config module file
    that was replaced with a find module file that has no
    path hard-coded in it. This should fix the failed builds on
    all the non x86_64 platforms.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 24 Aug 2020 15:45:21 +0200

libpappsomspp (0.7.11-1~buster+1) buster; urgency=medium

  * fix MassSpectrumWidget issue #3

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 17 Aug 2020 15:52:06 +0200

libpappsomspp (0.7.10-1~buster+1) buster; urgency=medium

  * buster package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 22 Jul 2020 11:04:12 +0200

libpappsomspp (0.7.10-1) unstable; urgency=low

  * New upstream version. Added new widget class to represent mass data
    to a TIC|XIC chromatogram / drift spectrum color map as requested 
    by a user.

  * Updates to the packaging.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 09 Jul 2020 09:26:14 +0200

libpappsomspp (0.7.9-1~buster+1) buster; urgency=medium

  * new version for debian buster pappsodev

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 01 Jul 2020 18:49:18 +0200

libpappsomspp (0.7.8-1~buster+1) buster; urgency=medium

  * Debian buster backport

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 10 Jun 2020 17:04:05 +0200

libpappsomspp (0.7.8-1) unstable; urgency=low

  * New upstream that has the src/custompwiz source directory
    removed. This lib now build-depends on another package: 
    libpwizlite-dev.

  * d/copyright was updated to reflect the removal of the pwiz code 
    subset. Note that 3 files were kept, modified and relocated to
    the pappsomspp source tree. These were documented in d/copyright.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 04 Jun 2020 18:21:53 +0200

libpappsomspp (0.7.7-2) buster; urgency=medium

  * packaging problem fixed

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 19 May 2020 15:47:42 +0200

libpappsomspp (0.7.7-1) buster; urgency=medium

  * a lot of warnings fixed, better virtual destructors

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 18 May 2020 10:31:35 +0200

libpappsomspp (0.7.6-1) UNRELEASED; urgency=low

  * Fixes for the CMake build system.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 28 Apr 2020 18:03:15 +0200

libpappsomspp (0.7.5-1) unstable; urgency=low

  * New upstream version with fixex for Qt5 suffix 
    remnants within CMake stuff. Also, use better 
    name for the libs in the CMake dialect 
    (PAPPSOMSPP becomes PappsoMSpp).
  
 -- Filippo Rusconi <lopippo@debian.org>  Tue, 28 Apr 2020 16:35:52 +0200

libpappsomspp (0.7.4-1) unstable; urgency=low

  * New upstream version with MultiArch support.

  * General review of the packaging for Debian official repos upload.
 
  * Full copyright holders info in d/copyright.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 22 Apr 2020 10:14:26 +0200

libpappsomspp (0.7.3-2) buster; urgency=medium

  * no more global include directories in cmake to fix compilation
    problems

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 20 Apr 2020 09:08:55 +0200

libpappsomspp (0.7.3-1) buster; urgency=medium

  * new system to export symbols for Windows system
  * filter pseudo centroid

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 15 Apr 2020 08:02:58 +0200

libpappsomspp (0.7.2-3) buster; urgency=medium

  * important fix in timsframe polynomial resolution

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sun, 12 Apr 2020 16:57:34 +0200

libpappsomspp (0.7.2-2) buster; urgency=medium

  * fix pappsomsconfig generation and install

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 10 Apr 2020 19:36:54 +0200

libpappsomspp (0.7.2-1) buster; urgency=medium

  * reworked cmake stuff

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 10 Apr 2020 10:26:45 +0200

libpappsomspp (0.7.1-1) buster; urgency=medium

  * brand new library, including libpwiz to avoid compilation problems

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 08 Apr 2020 18:26:53 +0200

libpappsomspp (0.7.0-1) unstable; urgency=low

  * New packaging for testing Debian sid package creation.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 18 Jan 2020 21:05:02 +0100

libpappsomspp (0.6.5-1ubuntu1) bionic; urgency=medium

  * ubuntu 18.04 package 

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 10 Jan 2020 21:59:22 +0000

libpappsomspp (0.6.5-1) buster; urgency=medium

  * catch pwiz runtime error
  * set scans number for mzXML files

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 08 Jan 2020 20:50:05 +0100

libpappsomspp (0.6.4-1) buster; urgency=medium

  * a lot of development from Filippo Rusconi and Olivier Langella

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 19 Dec 2019 21:55:55 +0100

libpappsomspp (0.6.3-2) buster; urgency=medium

  * buster package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 12 Sep 2019 15:23:58 +0200
